declare class BidirectionalMap<Key, Value> {
    #private;
    constructor(iterable?: Iterable<readonly [Key, Value]> | null);
    get size(): number;
    clear(): void;
    deleteLeft(key: Key): boolean;
    deleteRight(value: Value): boolean;
    getLeft(key: Key): Value | undefined;
    getRight(value: Value): Key | undefined;
    hasLeft(key: Key): boolean;
    hasRight(value: Value): boolean;
    set(key: Key, value: Value): this;
    [Symbol.iterator](): IterableIterator<[Key, Value]>;
    entries(): IterableIterator<[Key, Value]>;
    keys(): IterableIterator<Key>;
    values(): IterableIterator<Value>;
    get [Symbol.toStringTag](): string;
}

declare class MultiMap<Key, Value> {
    #private;
    constructor(iterable?: Iterable<readonly [Key, Value]> | null);
    get size(): number;
    clear(): void;
    delete(key: Key, value?: Value): boolean;
    get(key: Key): ReadonlySet<Value>;
    has(key: Key): boolean;
    set(key: Key, value: Value): this;
    [Symbol.iterator](): IterableIterator<[Key, Set<Value>]>;
    entries(): IterableIterator<[Key, ReadonlySet<Value>]>;
    keys(): IterableIterator<Key>;
    values(): IterableIterator<ReadonlySet<Value>>;
    get [Symbol.toStringTag](): string;
}

interface StructuralMultiMapOptions<Key> {
    hashFunction?: (key: Key) => string;
}
declare class StructuralMultiMap<Key, Value> {
    #private;
    constructor(iterable?: Iterable<readonly [Key, Value]> | null, options?: StructuralMultiMapOptions<Key>);
    get size(): number;
    clear(): void;
    delete(key: Key, value?: Value): boolean;
    get(key: Key): ReadonlySet<Value>;
    has(key: Key): boolean;
    set(key: Key, value: Value): this;
    [Symbol.iterator](): IterableIterator<[string, Set<Value>]>;
    entries(): IterableIterator<[Key, ReadonlySet<Value>]>;
    keys(): Generator<Key, void, unknown>;
    values(): IterableIterator<ReadonlySet<Value>>;
    [Symbol.toStringTag]: string;
}

export { BidirectionalMap, MultiMap, StructuralMultiMap };
