import { objectHash } from 'ohash';

var __accessCheck$2 = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet$2 = (obj, member, getter) => {
  __accessCheck$2(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd$2 = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var _left, _right;
class BidirectionalMap {
  constructor(iterable) {
    __privateAdd$2(this, _left, /* @__PURE__ */ new Map());
    __privateAdd$2(this, _right, /* @__PURE__ */ new Map());
    if (iterable) {
      for (const [key, value] of iterable) {
        __privateGet$2(this, _left).set(key, value);
        __privateGet$2(this, _right).set(value, key);
      }
    }
  }
  get size() {
    return __privateGet$2(this, _left).size;
  }
  clear() {
    __privateGet$2(this, _left).clear();
    __privateGet$2(this, _right).clear();
  }
  deleteLeft(key) {
    const value = __privateGet$2(this, _left).get(key);
    if (value !== void 0) {
      __privateGet$2(this, _left).delete(key);
      __privateGet$2(this, _right).delete(value);
      return true;
    }
    return false;
  }
  deleteRight(value) {
    const key = __privateGet$2(this, _right).get(value);
    if (key !== void 0) {
      __privateGet$2(this, _right).delete(value);
      __privateGet$2(this, _left).delete(key);
      return true;
    }
    return false;
  }
  getLeft(key) {
    return __privateGet$2(this, _left).get(key);
  }
  getRight(value) {
    return __privateGet$2(this, _right).get(value);
  }
  hasLeft(key) {
    return __privateGet$2(this, _left).has(key);
  }
  hasRight(value) {
    return __privateGet$2(this, _right).has(value);
  }
  set(key, value) {
    __privateGet$2(this, _left).set(key, value);
    __privateGet$2(this, _right).set(value, key);
    return this;
  }
  [Symbol.iterator]() {
    return __privateGet$2(this, _left)[Symbol.iterator]();
  }
  entries() {
    return __privateGet$2(this, _left).entries();
  }
  keys() {
    return __privateGet$2(this, _left).keys();
  }
  values() {
    return __privateGet$2(this, _left).values();
  }
  get [Symbol.toStringTag]() {
    return "BidirectionalMap";
  }
}
_left = new WeakMap();
_right = new WeakMap();

var __accessCheck$1 = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet$1 = (obj, member, getter) => {
  __accessCheck$1(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd$1 = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var _storage, _emptySet;
class MultiMap {
  constructor(iterable) {
    __privateAdd$1(this, _storage, /* @__PURE__ */ new Map());
    __privateAdd$1(this, _emptySet, /* @__PURE__ */ new Set());
    if (iterable) {
      for (const [key, value] of iterable) {
        this.set(key, value);
      }
    }
  }
  get size() {
    return __privateGet$1(this, _storage).size;
  }
  clear() {
    __privateGet$1(this, _storage).clear();
  }
  delete(key, value) {
    let existed = false;
    if (value !== void 0) {
      const storage = __privateGet$1(this, _storage).get(key);
      if (storage) {
        existed = storage.delete(value);
      }
    } else {
      existed = __privateGet$1(this, _storage).delete(key);
    }
    return existed;
  }
  get(key) {
    return __privateGet$1(this, _storage).get(key) ?? __privateGet$1(this, _emptySet);
  }
  has(key) {
    return __privateGet$1(this, _storage).has(key);
  }
  set(key, value) {
    let storage = __privateGet$1(this, _storage).get(key);
    if (!storage) {
      storage = /* @__PURE__ */ new Set();
      __privateGet$1(this, _storage).set(key, storage);
    }
    storage.add(value);
    return this;
  }
  [Symbol.iterator]() {
    return __privateGet$1(this, _storage)[Symbol.iterator]();
  }
  entries() {
    return __privateGet$1(this, _storage).entries();
  }
  keys() {
    return __privateGet$1(this, _storage).keys();
  }
  values() {
    return __privateGet$1(this, _storage).values();
  }
  get [Symbol.toStringTag]() {
    return "MultiMap";
  }
}
_storage = new WeakMap();
_emptySet = new WeakMap();

var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};
var _keys, _values, _hashFunction, _hash, hash_fn, _a;
class StructuralMultiMap {
  constructor(iterable, options = {}) {
    __privateAdd(this, _hash);
    __privateAdd(this, _keys, new BidirectionalMap(null));
    __privateAdd(this, _values, new MultiMap());
    __privateAdd(this, _hashFunction, void 0);
    __publicField(this, _a, "MultiMap");
    __privateSet(this, _hashFunction, options.hashFunction ?? objectHash);
    if (iterable) {
      for (const [key, value] of iterable) {
        const hash = __privateGet(this, _hashFunction).call(this, key);
        __privateGet(this, _keys).set(key, hash);
        __privateGet(this, _values).set(hash, value);
      }
    }
  }
  get size() {
    return __privateGet(this, _values).size;
  }
  clear() {
    __privateGet(this, _keys).clear();
    __privateGet(this, _values).clear();
  }
  delete(key, value) {
    return __privateGet(this, _values).delete(__privateMethod(this, _hash, hash_fn).call(this, key), value);
  }
  get(key) {
    return __privateGet(this, _values).get(__privateMethod(this, _hash, hash_fn).call(this, key));
  }
  has(key) {
    return __privateGet(this, _values).has(__privateMethod(this, _hash, hash_fn).call(this, key));
  }
  set(key, value) {
    __privateGet(this, _values).set(__privateMethod(this, _hash, hash_fn).call(this, key), value);
    return this;
  }
  [Symbol.iterator]() {
    return __privateGet(this, _values)[Symbol.iterator]();
  }
  *entries() {
    for (const [hash, values] of __privateGet(this, _values).entries()) {
      const key = __privateGet(this, _keys).getRight(hash);
      yield [key, values];
    }
  }
  *keys() {
    for (const hash of __privateGet(this, _values).keys()) {
      yield __privateGet(this, _keys).getRight(hash);
    }
  }
  values() {
    return __privateGet(this, _values).values();
  }
}
_a = Symbol.toStringTag;
_keys = new WeakMap();
_values = new WeakMap();
_hashFunction = new WeakMap();
_hash = new WeakSet();
hash_fn = function(key) {
  let hash = __privateGet(this, _keys).getLeft(key);
  if (!hash) {
    hash = __privateGet(this, _hashFunction).call(this, key);
    __privateGet(this, _keys).set(key, hash);
  }
  return hash;
};

export { BidirectionalMap, MultiMap, StructuralMultiMap };
